/* (c) 1999 Jimbo AEGiS Corp */
/* http://www.aegis-corp.org */
/*    Realesed under GPL     */ 

#define USE_PLUGIN

#include "/goinfre/xchat-1.1.3/src/xchat.h"
#include "/goinfre/xchat-1.1.3/src/plugin.h"

extern	struct module *module_find (char *name);
extern void handle_command(char *, struct session *, int,int);
struct server *my_serv;
int dict_cmd (struct session *sess, char *tbuf, char *word[], char *word_eol[]);
int translate_cmd (struct session *sess, char *tbuf, char *word[], char *word_eol[]);
int help_cmd (struct session *sess, char *tbuf, char *word[], char *word_eol[]);

char	*name = "AEGiS's dictionnary";
char	*desc = "some word helpers by AEGiS Corp.";

struct	commands	sample_cmds[] = {
     {"DICT",	dict_cmd,	0, 0, ""},
     {"TRANSLATE",   translate_cmd,       0, 0, ""},
     {"DICOHELP", help_cmd, 0, 0, ""},
     {0, 0, 0, 0, 0}
};

struct	module_cmd_set	sample_cmd_set;

int	module_init (int ver, struct module *mod, struct session *sess)
{
   /* This check *MUST* be done first */
   if (ver != MODULE_IFACE_VER)
     return 1;
   
   if (module_find (name) != NULL) {
      /* We are already loaded */
      PrintText(sess, "AEG\00310i\0030S Corp. Dictionnary module already loaded\n");
      return 1;
	}
   PrintText(sess, "AEG\00310,1i\0030,1S Corp. Dictionnary module Loaded.\n");

   mod->name = name;
   mod->desc = desc;
   
   sample_cmd_set.mod = mod;
   sample_cmd_set.cmds = sample_cmds;
   
   module_add_cmds (&sample_cmd_set);
   
   return 0;
}

void	module_cleanup (struct module *mod, struct session *sess)
{
	PrintText(sess, "AEG\00310i\0030S's Dictionnary module unloading\n");
}

int find(s,c)
char	*s;
char	c;
{
   while (*(s++))
     if (*s == c)
       return 1;
   return 0; 
}

int kill_br(s)
char	*s;
{
   int ret;
   
   ret = 0;
   while (*(s++))
     if (*s == 13)
       *s = ' ';
   else
     if (*s == '\200')
     {
	ret = 1;
	*s = ' ';
     }
   return (ret);
}

int     dict_cmd (struct session *sess, char *tbuf, char *word[], char *word_eol[])
{
   struct hostent       *host;
   int  socket;
   char	*cmd; 
   int	first;
   int	end;
   int	size;
   
   if (*word_eol[2])
     {
	cmd = malloc(501);
	sprintf(cmd,"\00314-\0030-\00315-\0030 Define %s \00315-\0030-\00314-\n",word_eol[2]);
	PrintText(sess,cmd);
	host = gethostbyname("128.52.39.7");
	socket = cl_connect(host,2627);
	sprintf(cmd,"DEFINE %s\n",word_eol[2]);
	write(socket,cmd,strlen(cmd));
	first = 1;
	do{
	   size = read(socket,cmd,500);
      end = kill_br(cmd);
	   cmd[size] = 0;
	   PrintText(sess,first?cmd+12:cmd);
	   first = 0;
	}
	while (!end);
	free (cmd);
	PrintText(sess,"\n");
     }
   else
     PrintText(sess,"Usage : /DICT <word>\n");
}

void	preparse(s)
char	*s;
{
   while (*s)
     {
	if (*s == ' ')
	  *s = '+';
	s++;
     }
}

int     translate_cmd (struct session *sess, char *tbuf, char *word[], char *word_eol[])
{
   struct hostent       *host;
   int  socket;
   char *cmd;
   char	*tmp;
   char	*tmp2;
   char	*tmp3;
   int  mode;
   int  size;
   
   if (*word_eol[3])
     {
	cmd = malloc(501);  
	sprintf(cmd,"\00314-\0030-\00315-\0030 Translating %s (%s) \00315-\0030-\00314-\n",word_eol[3],word[2]);
	PrintText(sess,cmd);
	preparse(word_eol[3]);
	host = gethostbyname("204.123.9.65");
	socket = cl_connect(host,80);
	sprintf(cmd,"GET /cgi-bin/translate?doit=done&urltext=%s&languagepair=%s\n",word_eol[3],word[2]);
	write(socket,cmd,strlen(cmd));
	mode = 0;
	do{
	   size = read(socket,cmd,500);
	   cmd[size] = 0;
	   tmp = 1;
	   tmp3=cmd;
	   while (tmp)
	     {
		if (tmp = strstr(tmp3,"<font face=\"arial, helvetica\">"))
		  {
		     tmp+=30;
		     mode++;
		  }
		if ((tmp2 = strstr(tmp?tmp:tmp3,"</b>")) || (tmp2 = strstr(tmp?tmp:tmp3,"<br>")))
		  {
		     *tmp2 = 0;
		     mode = 2;
		  }
		if (mode == 2)
		  {
		     if (tmp)
		       PrintText(sess,tmp);
		  }
		tmp3 = tmp;
	     }
	}
	while (size);
	free (cmd);
	PrintText(sess,"\n");	
     }
   else
     {
	PrintText(sess,"Usage : /TRANSLATE <lang> <sentence>\n");
	PrintText(sess,"Where \00315lang\0030 is one of the following:\n");
	PrintText(sess,"  en_fr		English    French\n");
	PrintText(sess,"  en_de	                   German\n");
	PrintText(sess,"  en_it                    Italian\n");
	PrintText(sess,"  en_pt                    Portuguese\n");
	PrintText(sess,"  en_es                    Spanish\n");
	PrintText(sess,"  fr_en         French     English\n");
	PrintText(sess,"  de_en         German\n");
	PrintText(sess,"  it_en         Italian\n");
	PrintText(sess,"  pt_en         Portuguese\n");
	PrintText(sess,"  es_en         Spanish\n");
     }
}

int     help_cmd (struct session *sess, char *tbuf, char *word[], char *word_eol[])
{
   PrintText(sess,"AEG\00310i\0030S Corp Dictionnary (c) Jimbo '99\n");
   PrintText(sess,"Command summary : \n");
   PrintText(sess," \00315- \0030/DICT <word> gives you the definition of \00315word\0030.\n");
   PrintText(sess," \00315- \0030/TRANSLATE <lang> <sentence> translates \00315sentence\0030 according to \00315lang\0030. (run it without parameters for explanations).\n");
}
